diff -cprN head/src/bin/pg_dump/pg_dump.c work/src/bin/pg_dump/pg_dump.c
*** head/src/bin/pg_dump/pg_dump.c	2010-01-18 09:26:23.915594000 +0900
--- work/src/bin/pg_dump/pg_dump.c	2010-01-18 14:38:33.989050564 +0900
*************** static void dumpUserMappings(Archive *fo
*** 165,170 ****
--- 165,171 ----
  				 const char *servername, const char *namespace,
  				 const char *owner, CatalogId catalogId, DumpId dumpId);
  static void dumpDefaultACL(Archive *fout, DefaultACLInfo *daclinfo);
+ static void dumpPartition(Archive *fout, PartitionInfo *partinfo);
  
  static void dumpACL(Archive *fout, CatalogId objCatId, DumpId objDumpId,
  		const char *type, const char *name, const char *subname,
*************** getInherits(int *numInherits)
*** 3853,3859 ****
  
  	/* find all the inheritance information */
  
! 	appendPQExpBuffer(query, "SELECT inhrelid, inhparent FROM pg_inherits");
  
  	res = PQexec(g_conn, query->data);
  	check_sql_result(res, g_conn, query->data, PGRES_TUPLES_OK);
--- 3854,3864 ----
  
  	/* find all the inheritance information */
  
! 	if (g_fout->remoteVersion >= 80500)
! 		appendPQExpBuffer(query, "SELECT inhrelid, inhparent FROM pg_inherits "
! 								 "WHERE inhvalues IS NULL");
! 	else
! 		appendPQExpBuffer(query, "SELECT inhrelid, inhparent FROM pg_inherits");
  
  	res = PQexec(g_conn, query->data);
  	check_sql_result(res, g_conn, query->data, PGRES_TUPLES_OK);
*************** getDefaultACLs(int *numDefaultACLs)
*** 6063,6068 ****
--- 6068,6141 ----
  }
  
  /*
+  * getTriggers
+  *	  get information about every partition on a dumpable table
+  *
+  * Note: partition data is not returned directly to the caller, but it
+  * does get entered into the DumpableObject tables.
+  */
+ void
+ getPartitions(TableInfo tblinfo[], int numTables)
+ {
+ 	int			i,
+ 				j;
+ 	PQExpBuffer query = createPQExpBuffer();
+ 	PGresult   *res;
+ 	PartitionInfo *partinfo;
+ 	int			i_partrelid,
+ 				i_partdef;
+ 	int			ntups;
+ 
+ 	if (g_fout->remoteVersion < 80500)
+ 		return;
+ 
+ 	appendPQExpBuffer(query,
+ 			  "SELECT "
+ 			  "partrelid, "
+ 			  "pg_get_partitiondef(partrelid, true) AS partdef "
+ 			  "FROM pg_partition");
+ 	res = PQexec(g_conn, query->data);
+ 	check_sql_result(res, g_conn, query->data, PGRES_TUPLES_OK);
+ 
+ 	i_partrelid = PQfnumber(res, "partrelid");
+ 	i_partdef = PQfnumber(res, "partdef");
+ 
+ 	ntups = PQntuples(res);
+ 	partinfo = (PartitionInfo *) malloc(ntups * sizeof(PartitionInfo));
+ 
+ 	for (j = 0; j < ntups; j++)
+ 	{
+ 		Oid		relid = atooid(PQgetvalue(res, j, i_partrelid));
+ 
+ 		for (i = 0; i < numTables; i++)
+ 		{
+ 			TableInfo  *tbinfo = &tblinfo[i];
+ 
+ 			if (tbinfo->dobj.catId.oid == relid)
+ 			{
+ 				if (g_verbose)
+ 					write_msg(NULL, "reading partition for table \"%s\"\n",
+ 							  tbinfo->dobj.name);
+ 
+ 				partinfo[j].dobj.objType = DO_PARTITION;
+ 				partinfo[j].dobj.catId.tableoid = 0;
+ 				partinfo[j].dobj.catId.oid = tbinfo->dobj.catId.oid;
+ 				AssignDumpId(&partinfo[j].dobj);
+ 				partinfo[j].dobj.name = tbinfo->dobj.name;
+ 				partinfo[j].dobj.namespace = tbinfo->dobj.namespace;
+ 				partinfo[j].dobj.dump = tbinfo->dobj.dump;
+ 				partinfo[j].parttable = tbinfo;
+ 				partinfo[j].partdef = strdup(PQgetvalue(res, j, i_partdef));
+ 				break;
+ 			}
+ 		}
+ 	}
+ 
+ 	PQclear(res);
+ 	destroyPQExpBuffer(query);
+ }
+ 
+ /*
   * dumpComment --
   *
   * This routine is used to dump any comments associated with the
*************** dumpDumpableObject(Archive *fout, Dumpab
*** 6494,6499 ****
--- 6567,6575 ----
  						 dobj->dependencies, dobj->nDeps,
  						 dumpBlobComments, NULL);
  			break;
+ 		case DO_PARTITION:
+ 			dumpPartition(fout, (PartitionInfo *) dobj);
+ 			break;
  	}
  }
  
*************** dumpRule(Archive *fout, RuleInfo *rinfo)
*** 11931,11936 ****
--- 12007,12047 ----
  }
  
  /*
+  * dumpPartition
+  *		Dump a partition
+  */
+ static void
+ dumpPartition(Archive *fout, PartitionInfo *partinfo)
+ {
+ 	TableInfo  *tbinfo = partinfo->parttable;
+ 	PQExpBuffer cmd;
+ 
+ 	/* Skip if not to be dumped */
+ 	if (!partinfo->dobj.dump || dataOnly)
+ 		return;
+ 
+ 	cmd = createPQExpBuffer();
+ 
+ 	appendPQExpBufferStr(cmd, partinfo->partdef);
+ 
+ 	/*
+ 	 * DROP must be fully qualified in case same name appears in pg_catalog
+ 	 */
+ 	ArchiveEntry(fout, partinfo->dobj.catId, partinfo->dobj.dumpId,
+ 				 partinfo->dobj.name,
+ 				 tbinfo->dobj.namespace->dobj.name,
+ 				 NULL,
+ 				 tbinfo->rolname, false,
+ 				 "PARTITION", SECTION_POST_DATA,
+ 				 cmd->data, "", NULL,
+ 				 partinfo->dobj.dependencies, partinfo->dobj.nDeps,
+ 				 NULL, NULL);
+ 
+ 	destroyPQExpBuffer(cmd);
+ }
+ 
+ 
+ /*
   * getDependencies --- obtain available dependency data
   */
  static void
diff -cprN head/src/bin/pg_dump/pg_dump.h work/src/bin/pg_dump/pg_dump.h
*** head/src/bin/pg_dump/pg_dump.h	2010-01-04 09:10:26.638773000 +0900
--- work/src/bin/pg_dump/pg_dump.h	2010-01-18 14:38:33.989050564 +0900
*************** typedef enum
*** 116,122 ****
  	DO_FOREIGN_SERVER,
  	DO_DEFAULT_ACL,
  	DO_BLOBS,
! 	DO_BLOB_COMMENTS
  } DumpableObjectType;
  
  typedef struct _dumpableObject
--- 116,123 ----
  	DO_FOREIGN_SERVER,
  	DO_DEFAULT_ACL,
  	DO_BLOBS,
! 	DO_BLOB_COMMENTS,
! 	DO_PARTITION
  } DumpableObjectType;
  
  typedef struct _dumpableObject
*************** typedef struct _defaultACLInfo
*** 442,447 ****
--- 443,455 ----
  	char	   *defaclacl;
  } DefaultACLInfo;
  
+ typedef struct _partitionInfo
+ {
+ 	DumpableObject dobj;
+ 	TableInfo  *parttable;		/* link to table the partition is for */
+ 	char	   *partdef;
+ } PartitionInfo;
+ 
  /* global decls */
  extern bool force_quotes;		/* double-quotes for identifiers flag */
  extern bool g_verbose;			/* verbose flag */
*************** extern TSConfigInfo *getTSConfigurations
*** 527,531 ****
--- 535,540 ----
  extern FdwInfo *getForeignDataWrappers(int *numForeignDataWrappers);
  extern ForeignServerInfo *getForeignServers(int *numForeignServers);
  extern DefaultACLInfo *getDefaultACLs(int *numDefaultACLs);
+ extern void getPartitions(TableInfo tblinfo[], int numTables);
  
  #endif   /* PG_DUMP_H */
diff -cprN head/src/bin/pg_dump/pg_dump_sort.c work/src/bin/pg_dump/pg_dump_sort.c
*** head/src/bin/pg_dump/pg_dump_sort.c	2010-01-04 09:10:26.638773000 +0900
--- work/src/bin/pg_dump/pg_dump_sort.c	2010-01-18 14:38:33.989050564 +0900
*************** static const int oldObjectTypePriority[]
*** 56,62 ****
  	4,							/* DO_FOREIGN_SERVER */
  	17,							/* DO_DEFAULT_ACL */
  	10,							/* DO_BLOBS */
! 	11							/* DO_BLOB_COMMENTS */
  };
  
  /*
--- 56,63 ----
  	4,							/* DO_FOREIGN_SERVER */
  	17,							/* DO_DEFAULT_ACL */
  	10,							/* DO_BLOBS */
! 	11,							/* DO_BLOB_COMMENTS */
! 	18							/* DO_PARTITION */
  };
  
  /*
*************** static const int newObjectTypePriority[]
*** 76,89 ****
  	9,							/* DO_CONVERSION */
  	16,							/* DO_TABLE */
  	18,							/* DO_ATTRDEF */
! 	23,							/* DO_INDEX */
! 	24,							/* DO_RULE */
! 	25,							/* DO_TRIGGER */
! 	22,							/* DO_CONSTRAINT */
! 	26,							/* DO_FK_CONSTRAINT */
  	2,							/* DO_PROCLANG */
  	8,							/* DO_CAST */
! 	19,							/* DO_TABLE_DATA */
  	17,							/* DO_DUMMY_TYPE */
  	10,							/* DO_TSPARSER */
  	12,							/* DO_TSDICT */
--- 77,90 ----
  	9,							/* DO_CONVERSION */
  	16,							/* DO_TABLE */
  	18,							/* DO_ATTRDEF */
! 	24,							/* DO_INDEX */
! 	25,							/* DO_RULE */
! 	26,							/* DO_TRIGGER */
! 	23,							/* DO_CONSTRAINT */
! 	27,							/* DO_FK_CONSTRAINT */
  	2,							/* DO_PROCLANG */
  	8,							/* DO_CAST */
! 	20,							/* DO_TABLE_DATA */
  	17,							/* DO_DUMMY_TYPE */
  	10,							/* DO_TSPARSER */
  	12,							/* DO_TSDICT */
*************** static const int newObjectTypePriority[]
*** 91,99 ****
  	13,							/* DO_TSCONFIG */
  	14,							/* DO_FDW */
  	15,							/* DO_FOREIGN_SERVER */
! 	27,							/* DO_DEFAULT_ACL */
! 	20,							/* DO_BLOBS */
! 	21							/* DO_BLOB_COMMENTS */
  };
  
  
--- 92,101 ----
  	13,							/* DO_TSCONFIG */
  	14,							/* DO_FDW */
  	15,							/* DO_FOREIGN_SERVER */
! 	28,							/* DO_DEFAULT_ACL */
! 	21,							/* DO_BLOBS */
! 	22,							/* DO_BLOB_COMMENTS */
! 	19							/* DO_PARTITION */
  };
  
  
*************** describeDumpableObject(DumpableObject *o
*** 1156,1161 ****
--- 1158,1168 ----
  					 "BLOB COMMENTS  (ID %d)",
  					 obj->dumpId);
  			return;
+ 		case DO_PARTITION:
+ 			snprintf(buf, bufsize,
+ 					 "PARTITION %s  (ID %d OID %u)",
+ 					 obj->name, obj->dumpId, obj->catId.oid);
+ 			return;
  	}
  	/* shouldn't get here */
  	snprintf(buf, bufsize,
diff -cprN head/src/bin/psql/describe.c work/src/bin/psql/describe.c
*** head/src/bin/psql/describe.c	2010-01-18 09:26:23.915594000 +0900
--- work/src/bin/psql/describe.c	2010-01-18 14:38:33.990414828 +0900
*************** describeOneTableDetails(const char *sche
*** 1987,1994 ****
  		}
  		PQclear(result);
  
  		/* print child tables */
! 		if (pset.sversion >= 80300)
  			printfPQExpBuffer(&buf, "SELECT c.oid::pg_catalog.regclass FROM pg_catalog.pg_class c, pg_catalog.pg_inherits i WHERE c.oid=i.inhrelid AND i.inhparent = '%s' ORDER BY c.oid::pg_catalog.regclass::pg_catalog.text;", oid);
  		else
  			printfPQExpBuffer(&buf, "SELECT c.oid::pg_catalog.regclass FROM pg_catalog.pg_class c, pg_catalog.pg_inherits i WHERE c.oid=i.inhrelid AND i.inhparent = '%s' ORDER BY c.relname;", oid);
--- 1987,2010 ----
  		}
  		PQclear(result);
  
+ 		/* print partitions */
+ 		if (pset.sversion >= 80500)
+ 		{
+ 			printfPQExpBuffer(&buf, "SELECT pg_catalog.pg_get_partitiondef('%s', false);", oid);
+ 			result = PSQLexec(buf.data, false);
+ 			if (!result)
+ 				goto error_return;
+ 			if (PQntuples(result) > 0 && !PQgetisnull(result, 0, 0))
+ 			{
+ 				printfPQExpBuffer(&buf, _("Partitions: %s"), PQgetvalue(result, 0, 0));
+ 				printTableAddFooter(&cont, buf.data);
+ 			}
+ 		}
+ 
  		/* print child tables */
! 		if (pset.sversion >= 80500)
! 			printfPQExpBuffer(&buf, "SELECT c.oid::pg_catalog.regclass FROM pg_catalog.pg_class c, pg_catalog.pg_inherits i WHERE c.oid=i.inhrelid AND i.inhparent = '%s' AND i.inhvalues IS NULL ORDER BY c.oid::pg_catalog.regclass::pg_catalog.text;", oid);
! 		else if (pset.sversion >= 80300)
  			printfPQExpBuffer(&buf, "SELECT c.oid::pg_catalog.regclass FROM pg_catalog.pg_class c, pg_catalog.pg_inherits i WHERE c.oid=i.inhrelid AND i.inhparent = '%s' ORDER BY c.oid::pg_catalog.regclass::pg_catalog.text;", oid);
  		else
  			printfPQExpBuffer(&buf, "SELECT c.oid::pg_catalog.regclass FROM pg_catalog.pg_class c, pg_catalog.pg_inherits i WHERE c.oid=i.inhrelid AND i.inhparent = '%s' ORDER BY c.relname;", oid);
diff -cprN head/src/include/catalog/dependency.h work/src/include/catalog/dependency.h
*** head/src/include/catalog/dependency.h	2010-01-04 09:10:26.638773000 +0900
--- work/src/include/catalog/dependency.h	2010-01-18 14:38:33.991041919 +0900
*************** typedef enum ObjectClass
*** 148,153 ****
--- 148,154 ----
  	OCLASS_FOREIGN_SERVER,		/* pg_foreign_server */
  	OCLASS_USER_MAPPING,		/* pg_user_mapping */
  	OCLASS_DEFACL,				/* pg_default_acl */
+ 	OCLASS_PARTITION,			/* pg_partition */
  	MAX_OCLASS					/* MUST BE LAST */
  } ObjectClass;
  
diff -cprN head/src/include/catalog/heap.h work/src/include/catalog/heap.h
*** head/src/include/catalog/heap.h	2010-01-04 09:10:26.638773000 +0900
--- work/src/include/catalog/heap.h	2010-01-18 14:38:33.991041919 +0900
*************** extern Node *cookDefault(ParseState *pst
*** 93,98 ****
--- 93,101 ----
  			Oid atttypid,
  			int32 atttypmod,
  			char *attname);
+ extern Node *cookConstraint(ParseState *pstate,
+ 			   Node *raw_constraint,
+ 			   char *relname);
  
  extern void DeleteRelationTuple(Oid relid);
  extern void DeleteAttributeTuples(Oid relid);
*************** extern void RemoveAttrDefault(Oid relid,
*** 101,106 ****
--- 104,110 ----
  				  DropBehavior behavior, bool complain);
  extern void RemoveAttrDefaultById(Oid attrdefId);
  extern void RemoveStatistics(Oid relid, AttrNumber attnum);
+ extern void RemovePartition(Oid relid);
  
  extern Form_pg_attribute SystemAttributeDefinition(AttrNumber attno,
  						  bool relhasoids);
diff -cprN head/src/include/catalog/indexing.h work/src/include/catalog/indexing.h
*** head/src/include/catalog/indexing.h	2010-01-18 09:26:23.915594000 +0900
--- work/src/include/catalog/indexing.h	2010-01-18 14:38:33.991041919 +0900
*************** DECLARE_UNIQUE_INDEX(pg_default_acl_oid_
*** 281,286 ****
--- 281,289 ----
  DECLARE_UNIQUE_INDEX(pg_db_role_setting_databaseid_rol_index, 2965, on pg_db_role_setting using btree(setdatabase oid_ops, setrole oid_ops));
  #define DbRoleSettingDatidRolidIndexId	2965
  
+ DECLARE_UNIQUE_INDEX(pg_partition_relid_index, 2998, on pg_partition using btree(partrelid oid_ops));
+ #define PartitionRelidIndexId	2998
+ 
  /* last step of initialization script: build the indexes declared above */
  BUILD_INDICES
  
diff -cprN head/src/include/catalog/pg_inherits.h work/src/include/catalog/pg_inherits.h
*** head/src/include/catalog/pg_inherits.h	2010-01-05 10:25:20.891034000 +0900
--- work/src/include/catalog/pg_inherits.h	2010-01-18 14:38:33.991041919 +0900
***************
*** 21,26 ****
--- 21,29 ----
  
  #include "catalog/genbki.h"
  
+ /* See comments in pg_statistic.h. */
+ #define anyarray int
+ 
  /* ----------------
   *		pg_inherits definition.  cpp turns this into
   *		typedef struct FormData_pg_inherits
*************** CATALOG(pg_inherits,2611) BKI_WITHOUT_OI
*** 33,38 ****
--- 36,42 ----
  	Oid			inhrelid;
  	Oid			inhparent;
  	int4		inhseqno;
+ 	anyarray	inhvalues;	/* values for partition */
  } FormData_pg_inherits;
  
  /* ----------------
*************** typedef FormData_pg_inherits *Form_pg_in
*** 46,55 ****
   *		compiler constants for pg_inherits
   * ----------------
   */
! #define Natts_pg_inherits				3
  #define Anum_pg_inherits_inhrelid		1
  #define Anum_pg_inherits_inhparent		2
  #define Anum_pg_inherits_inhseqno		3
  
  /* ----------------
   *		pg_inherits has no initial contents
--- 50,60 ----
   *		compiler constants for pg_inherits
   * ----------------
   */
! #define Natts_pg_inherits				4
  #define Anum_pg_inherits_inhrelid		1
  #define Anum_pg_inherits_inhparent		2
  #define Anum_pg_inherits_inhseqno		3
+ #define Anum_pg_inherits_inhvalues		4
  
  /* ----------------
   *		pg_inherits has no initial contents
diff -cprN head/src/include/catalog/pg_inherits_fn.h work/src/include/catalog/pg_inherits_fn.h
*** head/src/include/catalog/pg_inherits_fn.h	2010-01-04 09:10:26.638773000 +0900
--- work/src/include/catalog/pg_inherits_fn.h	2010-01-18 14:38:33.991041919 +0900
***************
*** 17,24 ****
--- 17,36 ----
  #include "nodes/pg_list.h"
  #include "storage/lock.h"
  
+ /*
+  * Partition - store partition values.
+  */
+ typedef struct Partition
+ {
+ 	Oid		relid;
+ 	int		nvalues;
+ 	Datum  *values;
+ } Partition;
+ 
  extern List *find_inheritance_children(Oid parentrelId, LOCKMODE lockmode);
  extern List *find_all_inheritors(Oid parentrelId, LOCKMODE lockmode);
+ extern List *get_partitions(Oid parentrelId,
+ 							 char *kind, Node **key, Oid *opclass);
  extern bool has_subclass(Oid relationId);
  extern bool typeInheritsFrom(Oid subclassTypeId, Oid superclassTypeId);
  
diff -cprN head/src/include/catalog/pg_partition.h work/src/include/catalog/pg_partition.h
*** head/src/include/catalog/pg_partition.h	1970-01-01 09:00:00.000000000 +0900
--- work/src/include/catalog/pg_partition.h	2010-01-18 14:38:33.991041919 +0900
***************
*** 0 ****
--- 1,55 ----
+ /*-------------------------------------------------------------------------
+  *
+  * pg_partition.h
+  *	  definition of the system "partition" relation (pg_partition)
+  *	  along with the relation's initial contents.
+  *
+  *
+  * Portions Copyright (c) 1996-2009, PostgreSQL Global Development Group
+  *
+  * $PostgreSQL: pgsql/src/include/catalog/pg_partition.h $
+  *
+  * NOTES
+  *	  the genbki.sh script reads this file and generates .bki
+  *	  information from the DATA() statements.
+  *
+  *-------------------------------------------------------------------------
+  */
+ #ifndef PG_PARTITION_H
+ #define PG_PARTITION_H
+ 
+ #include "catalog/genbki.h"
+ 
+ /* ----------------
+  *		pg_partition definition.  cpp turns this into
+  *		typedef struct FormData_pg_partitions
+  * ----------------
+  */
+ #define PartitionRelationId 2997
+ 
+ CATALOG(pg_partition,2997) BKI_WITHOUT_OIDS
+ {
+ 	Oid		partrelid;		/* partitioned table oid */
+ 	Oid		partopclass;	/* operator class to compare keys */
+ 	char	partkind;		/* kind of partition: RANGE or LIST */
+ 	text	partkey;		/* partition key expression */
+ } FormData_pg_partition;
+ 
+ /* ----------------
+  *      Form_pg_partitions corresponds to a pointer to a tuple with
+  *      the format of pg_partitions relation.
+  * ----------------
+  */
+ typedef FormData_pg_partition *Form_pg_partition;
+ 
+ /* ----------------
+  *      compiler constants for pg_partitions
+  * ----------------
+  */
+ #define Natts_pg_partition				4
+ #define Anum_pg_partition_partrelid		1
+ #define Anum_pg_partition_partopclass	2
+ #define Anum_pg_partition_partkind		3
+ #define Anum_pg_partition_partkey		4
+ 
+ #endif   /* PG_PARTITIONS_H */
diff -cprN head/src/include/catalog/pg_proc.h work/src/include/catalog/pg_proc.h
*** head/src/include/catalog/pg_proc.h	2010-01-18 09:26:23.915594000 +0900
--- work/src/include/catalog/pg_proc.h	2010-01-18 14:38:33.993117056 +0900
*************** DATA(insert OID = 2232 (  pg_get_functio
*** 2315,2320 ****
--- 2315,2322 ----
  DESCR("identity argument list of a function");
  DATA(insert OID = 2165 (  pg_get_function_result	   PGNSP PGUID 12 1 0 0 f f f t f s 1 0 25 "26" _null_ _null_ _null_ _null_ pg_get_function_result _null_ _null_ _null_ ));
  DESCR("result type of a function");
+ DATA(insert OID = 2999 (  pg_get_partitiondef	PGNSP PGUID 12 1 0 0 f f f t f s 2 0 25 "26 16" _null_ _null_ _null_ _null_	pg_get_partitiondef _null_ _null_ _null_ ));
+ DESCR("definition of a partition");
  
  DATA(insert OID = 1686 (  pg_get_keywords		PGNSP PGUID 12 10 400 0 f f f t t s 0 0 2249 "" "{25,18,25}" "{o,o,o}" "{word,catcode,catdesc}" _null_ pg_get_keywords _null_ _null_ _null_ ));
  DESCR("list of SQL keywords");
diff -cprN head/src/include/commands/defrem.h work/src/include/commands/defrem.h
*** head/src/include/commands/defrem.h	2010-01-04 09:10:26.638773000 +0900
--- work/src/include/commands/defrem.h	2010-01-18 14:38:33.993117056 +0900
*************** extern char *ChooseIndexName(const char 
*** 50,55 ****
--- 50,57 ----
  							 bool primary, bool isconstraint);
  extern List *ChooseIndexColumnNames(List *indexElems);
  extern Oid	GetDefaultOpClass(Oid type_id, Oid am_id);
+ extern Oid	GetIndexOpClass(List *opclass, Oid attrType,
+ 				const char *accessMethodName, Oid accessMethodId);
  
  /* commands/functioncmds.c */
  extern void CreateFunction(CreateFunctionStmt *stmt, const char *queryString);
diff -cprN head/src/include/commands/tablecmds.h work/src/include/commands/tablecmds.h
*** head/src/include/commands/tablecmds.h	2010-01-04 09:10:26.638773000 +0900
--- work/src/include/commands/tablecmds.h	2010-01-18 14:38:33.994086938 +0900
*************** extern void RenameRelationInternal(Oid m
*** 53,58 ****
--- 53,60 ----
  					   const char *newrelname,
  					   Oid namespaceId);
  
+ extern void CreatePartition(CreatePartitionStmt *stmt, const char *queryString);
+ 
  extern void find_composite_type_dependencies(Oid typeOid,
  								 const char *origTblName,
  								 const char *origTypeName);
diff -cprN head/src/include/nodes/nodes.h work/src/include/nodes/nodes.h
*** head/src/include/nodes/nodes.h	2010-01-06 09:46:25.748744000 +0900
--- work/src/include/nodes/nodes.h	2010-01-18 14:38:33.994086938 +0900
*************** typedef enum NodeTag
*** 347,352 ****
--- 347,353 ----
  	T_AlterUserMappingStmt,
  	T_DropUserMappingStmt,
  	T_AlterTableSpaceOptionsStmt,
+ 	T_CreatePartitionStmt,
  
  	/*
  	 * TAGS FOR PARSE TREE NODES (parsenodes.h)
*************** typedef enum NodeTag
*** 385,390 ****
--- 386,394 ----
  	T_XmlSerialize,
  	T_WithClause,
  	T_CommonTableExpr,
+ 	T_PartitionDef,
+ 	T_PartitionBy,
+ 	T_AddInherit,
  
  	/*
  	 * TAGS FOR RANDOM OTHER STUFF
diff -cprN head/src/include/nodes/parsenodes.h work/src/include/nodes/parsenodes.h
*** head/src/include/nodes/parsenodes.h	2010-01-18 09:26:23.915594000 +0900
--- work/src/include/nodes/parsenodes.h	2010-01-18 14:38:33.994086938 +0900
*************** typedef enum AlterTableType
*** 1135,1141 ****
  	AT_EnableReplicaRule,		/* ENABLE REPLICA RULE name */
  	AT_DisableRule,				/* DISABLE RULE name */
  	AT_AddInherit,				/* INHERIT parent */
! 	AT_DropInherit				/* NO INHERIT parent */
  } AlterTableType;
  
  typedef struct AlterTableCmd	/* one subcommand of an ALTER TABLE */
--- 1135,1144 ----
  	AT_EnableReplicaRule,		/* ENABLE REPLICA RULE name */
  	AT_DisableRule,				/* DISABLE RULE name */
  	AT_AddInherit,				/* INHERIT parent */
! 	AT_DropInherit,				/* NO INHERIT parent */
! 	AT_PartitionBy,				/* PARTITION BY / NO PARTITION */
! 	AT_AttachPartition,			/* ATTACH PARTITION */
! 	AT_DetachPartition			/* DETACH PARTITION */
  } AlterTableType;
  
  typedef struct AlterTableCmd	/* one subcommand of an ALTER TABLE */
*************** typedef struct VariableShowStmt
*** 1337,1342 ****
--- 1340,1379 ----
  	char	   *name;
  } VariableShowStmt;
  
+ /* ----------
+  * Partitioning definitions
+  * ----------
+  */
+ 
+ #define	PARTITION_BY_RANGE		'r'
+ #define	PARTITION_BY_LIST		'l'
+ 
+ typedef struct PartitionDef
+ {
+ 	NodeTag			type;
+ 	char			kind;			/* PARTITION_BY_xxx */
+ 	RangeVar	   *name;			/* name of partition */
+ 	List		   *values;			/* for RANGE and LIST */
+ 	List		   *options;		/* options from WITH clause */
+ 	char		   *tablespacename; /* table space to use, or NULL */
+ } PartitionDef;
+ 
+ typedef struct PartitionBy
+ {
+ 	NodeTag			type;
+ 	char			kind;			/* PARTITION_BY_xxx */
+ 	Node		   *key;			/* partition key expr */
+ 	List		   *opclass;		/* partition key operator class */
+ 	List		   *defs;			/* list of PartitionDef */
+ } PartitionBy;
+ 
+ typedef struct CreatePartitionStmt
+ {
+ 	NodeTag			type;
+ 	RangeVar	   *parent;			/* parent of the partition */
+ 	PartitionDef   *def;
+ } CreatePartitionStmt;
+ 
  /* ----------------------
   *		Create Table Statement
   *
*************** typedef struct CreateStmt
*** 1359,1364 ****
--- 1396,1402 ----
  	List	   *options;		/* options from WITH clause */
  	OnCommitAction oncommit;	/* what do we do at COMMIT? */
  	char	   *tablespacename; /* table space to use, or NULL */
+ 	PartitionBy *partitions;	/* partitioning definition, or NULL */
  } CreateStmt;
  
  /* ----------
diff -cprN head/src/include/parser/kwlist.h work/src/include/parser/kwlist.h
*** head/src/include/parser/kwlist.h	2010-01-06 14:42:58.290140000 +0900
--- work/src/include/parser/kwlist.h	2010-01-18 14:38:33.995186934 +0900
*************** PG_KEYWORD("assertion", ASSERTION, UNRES
*** 49,54 ****
--- 49,55 ----
  PG_KEYWORD("assignment", ASSIGNMENT, UNRESERVED_KEYWORD)
  PG_KEYWORD("asymmetric", ASYMMETRIC, RESERVED_KEYWORD)
  PG_KEYWORD("at", AT, UNRESERVED_KEYWORD)
+ PG_KEYWORD("attach", ATTACH, UNRESERVED_KEYWORD)
  PG_KEYWORD("authorization", AUTHORIZATION, TYPE_FUNC_NAME_KEYWORD)
  PG_KEYWORD("backward", BACKWARD, UNRESERVED_KEYWORD)
  PG_KEYWORD("before", BEFORE, UNRESERVED_KEYWORD)
*************** PG_KEYWORD("delete", DELETE_P, UNRESERVE
*** 125,130 ****
--- 126,132 ----
  PG_KEYWORD("delimiter", DELIMITER, UNRESERVED_KEYWORD)
  PG_KEYWORD("delimiters", DELIMITERS, UNRESERVED_KEYWORD)
  PG_KEYWORD("desc", DESC, RESERVED_KEYWORD)
+ PG_KEYWORD("detach", DETACH, UNRESERVED_KEYWORD)
  PG_KEYWORD("dictionary", DICTIONARY, UNRESERVED_KEYWORD)
  PG_KEYWORD("disable", DISABLE_P, UNRESERVED_KEYWORD)
  PG_KEYWORD("discard", DISCARD, UNRESERVED_KEYWORD)
*************** PG_KEYWORD("lc_ctype", LC_CTYPE_P, UNRES
*** 217,225 ****
--- 219,229 ----
  PG_KEYWORD("leading", LEADING, RESERVED_KEYWORD)
  PG_KEYWORD("least", LEAST, COL_NAME_KEYWORD)
  PG_KEYWORD("left", LEFT, TYPE_FUNC_NAME_KEYWORD)
+ PG_KEYWORD("less", LESS, UNRESERVED_KEYWORD)
  PG_KEYWORD("level", LEVEL, UNRESERVED_KEYWORD)
  PG_KEYWORD("like", LIKE, TYPE_FUNC_NAME_KEYWORD)
  PG_KEYWORD("limit", LIMIT, RESERVED_KEYWORD)
+ PG_KEYWORD("list", LIST, UNRESERVED_KEYWORD)
  PG_KEYWORD("listen", LISTEN, UNRESERVED_KEYWORD)
  PG_KEYWORD("load", LOAD, UNRESERVED_KEYWORD)
  PG_KEYWORD("local", LOCAL, UNRESERVED_KEYWORD)
*************** PG_KEYWORD("temp", TEMP, UNRESERVED_KEYW
*** 365,370 ****
--- 369,375 ----
  PG_KEYWORD("template", TEMPLATE, UNRESERVED_KEYWORD)
  PG_KEYWORD("temporary", TEMPORARY, UNRESERVED_KEYWORD)
  PG_KEYWORD("text", TEXT_P, UNRESERVED_KEYWORD)
+ PG_KEYWORD("than", THAN, UNRESERVED_KEYWORD)
  PG_KEYWORD("then", THEN, RESERVED_KEYWORD)
  PG_KEYWORD("time", TIME, COL_NAME_KEYWORD)
  PG_KEYWORD("timestamp", TIMESTAMP, COL_NAME_KEYWORD)
diff -cprN head/src/include/parser/parse_utilcmd.h work/src/include/parser/parse_utilcmd.h
*** head/src/include/parser/parse_utilcmd.h	2010-01-04 09:10:26.638773000 +0900
--- work/src/include/parser/parse_utilcmd.h	2010-01-18 14:38:33.995186934 +0900
*************** extern IndexStmt *transformIndexStmt(Ind
*** 24,28 ****
--- 24,29 ----
  extern void transformRuleStmt(RuleStmt *stmt, const char *queryString,
  				  List **actions, Node **whereClause);
  extern List *transformCreateSchemaStmt(CreateSchemaStmt *stmt);
+ extern List *transformCreatePartition(PartitionDef *def, RangeVar *parent);
  
  #endif   /* PARSE_UTILCMD_H */
diff -cprN head/src/include/utils/builtins.h work/src/include/utils/builtins.h
*** head/src/include/utils/builtins.h	2010-01-04 09:10:26.638773000 +0900
--- work/src/include/utils/builtins.h	2010-01-18 14:38:33.995186934 +0900
*************** extern Datum pg_get_functiondef(PG_FUNCT
*** 601,606 ****
--- 601,607 ----
  extern Datum pg_get_function_arguments(PG_FUNCTION_ARGS);
  extern Datum pg_get_function_identity_arguments(PG_FUNCTION_ARGS);
  extern Datum pg_get_function_result(PG_FUNCTION_ARGS);
+ extern Datum pg_get_partitiondef(PG_FUNCTION_ARGS);
  extern char *deparse_expression(Node *expr, List *dpcontext,
  				   bool forceprefix, bool showimplicit);
  extern List *deparse_context_for(const char *aliasname, Oid relid);
diff -cprN head/src/include/utils/lsyscache.h work/src/include/utils/lsyscache.h
*** head/src/include/utils/lsyscache.h	2010-01-05 09:17:58.505600000 +0900
--- work/src/include/utils/lsyscache.h	2010-01-18 14:38:33.995186934 +0900
*************** extern Oid	get_opclass_family(Oid opclas
*** 66,71 ****
--- 66,72 ----
  extern Oid	get_opclass_input_type(Oid opclass);
  extern RegProcedure get_opcode(Oid opno);
  extern char *get_opname(Oid opno);
+ extern List *get_opfullname(Oid opno);
  extern void op_input_types(Oid opno, Oid *lefttype, Oid *righttype);
  extern bool op_mergejoinable(Oid opno);
  extern bool op_hashjoinable(Oid opno);
diff -cprN head/src/include/utils/syscache.h work/src/include/utils/syscache.h
*** head/src/include/utils/syscache.h	2010-01-06 09:46:25.748744000 +0900
--- work/src/include/utils/syscache.h	2010-01-18 14:38:33.996065868 +0900
*************** enum SysCacheIdentifier
*** 84,90 ****
  	TYPENAMENSP,
  	TYPEOID,
  	USERMAPPINGOID,
! 	USERMAPPINGUSERSERVER
  };
  
  extern void InitCatalogCache(void);
--- 84,91 ----
  	TYPENAMENSP,
  	TYPEOID,
  	USERMAPPINGOID,
! 	USERMAPPINGUSERSERVER,
! 	PARTITIONKEY
  };
  
  extern void InitCatalogCache(void);
diff -cprN head/src/test/regress/parallel_schedule work/src/test/regress/parallel_schedule
*** head/src/test/regress/parallel_schedule	2009-08-25 09:55:55.804564000 +0900
--- work/src/test/regress/parallel_schedule	2010-01-18 14:38:33.997046457 +0900
*************** test: copy copyselect
*** 52,58 ****
  # ----------
  # Another group of parallel tests
  # ----------
! test: constraints triggers create_misc create_aggregate create_operator inherit vacuum drop_if_exists create_cast
  
  # Depends on the above
  test: create_index create_view
--- 52,58 ----
  # ----------
  # Another group of parallel tests
  # ----------
! test: constraints triggers create_misc create_aggregate create_operator inherit partition vacuum drop_if_exists create_cast
  
  # Depends on the above
  test: create_index create_view
diff -cprN head/src/test/regress/serial_schedule work/src/test/regress/serial_schedule
*** head/src/test/regress/serial_schedule	2009-08-25 09:55:55.804564000 +0900
--- work/src/test/regress/serial_schedule	2010-01-18 14:38:33.997046457 +0900
*************** test: create_operator
*** 60,65 ****
--- 60,66 ----
  test: create_index
  test: drop_if_exists
  test: inherit
+ test: partition
  test: vacuum
  test: create_view
  test: sanity_check
